package com.vp.plugin.sample.highlight.actions;

import java.util.*;

import com.vp.plugin.*;
import com.vp.plugin.action.*;
import com.vp.plugin.diagram.*;
import com.vp.plugin.diagram.shape.IRegionUIModel;
import com.vp.plugin.diagram.shape.IState2UIModel;

public final class HighlightController implements VPActionController {
	public void performAction(VPAction aAction) {
		// retrieve active diagram from your project
		DiagramManager lDiagramManager = ApplicationManager.instance().getDiagramManager();
		IDiagramUIModel lDiagram = lDiagramManager.getActiveDiagram();
		if (lDiagram != null) {
			// generate a random number between 1 to 5
			int lCount = (int) (Math.random() * 5);
			if (lCount == 0) {
				lCount = 1;
			}
			// retrieve the elements in diagram into an array
			IDiagramElement[] lDiagramElements = lDiagram.toDiagramElementArray();
			int lDiagramElementLength = lDiagramElements.length;
			if (lDiagramElementLength > 0) {
				// convert the elements into a List
				List<IDiagramElement> lDiagramElementList = new ArrayList<IDiagramElement>(Arrays.asList(lDiagramElements));
				for (int i = 0; i < lDiagramElementLength; i++) {
					// random reorder the element into another list 
					int lIndex = (int) (Math.random() * lDiagramElements.length);
					if (i != lIndex) {
						IDiagramElement lDiagramElementA = lDiagramElementList.get(lIndex);
						lDiagramElementList.set(lIndex, lDiagramElementList.get(i));
						lDiagramElementList.set(i, lDiagramElementA);
					}
				}
				// reduce the number of elements to retrieve account to the random number previously generated 
				if (lDiagramElementList.size() > lCount) {
					lDiagramElementList = lDiagramElementList.subList(0, lCount);
				}
				// highlight the element on diagram
				lDiagramManager.highlightAsAnimation(lDiagramElementList.toArray(new IDiagramElement[lDiagramElementList.size()]));			
			}
		}
	}	
	
	@Override
	public void update(VPAction aAction) {
	}
}